<template>
   <div class="container">
    <h1>Üritused</h1>
    <table class="table">
    <thead>
    <tr>
      <th scope="col">Nimi</th>
      <th scope="col">Koht</th>
      <th scope="col">Aeg</th>
      <th scope="col">Lisainfo</th>
      <th scope="col"></th>
      <th scope="col"></th>
    </tr>
  </thead>
  <tbody>
    <tr v-for="item in events" :key="item.uid">
      <td>
        <router-link
          :to="{ name: 'eventdetails', params: { event_uid: item.uid }}">{{ item.nimi }}
        </router-link>
      </td>
      <td>{{ item.koht }}</td>
      <td>{{ formatDate(item.aeg) }}</td>
      <td>{{ item.lisainfo }}</td>
      <td>
        <router-link
          :to="{ name: 'addguest', params: { event_uid: item.uid }}">Lisa osaleja
        </router-link>
      </td>
      <td>
        <div v-if="Date.now() < new Date(item.aeg)">
          <a href="/"
            @click="(event) => rmEvent(item.uid, event)">
            Kustuta sündmus</a>
          </div>
      </td>
    </tr>
    </tbody>
    </table>
    <router-link to="/newevent">Lisa uus üritus</router-link>
</div>
</template>

<script>
import axios from 'axios';

export default {
  name: 'HomeComponent',
  data() {
    return {
      events: [],
    };
  },
  methods: {
    getAllEvents() {
      axios.get('http://localhost:5000/yritus')
        .then((res) => {
          this.events = res.data;
        })
        .catch((error) => {
          // eslint-disable-next-line
          console.error(error);
        });
    },
    rmEvent(evtId, event) {
      event.preventDefault();
      if (window.confirm('Oled kindel?') === true) {
        axios.delete(`http://localhost:5000/yritus/${evtId}`)
          .then(() => {
            window.location.href = '/';
          })
          .catch((error) => {
            // eslint-disable-next-line
            console.error(error);
          });
      }
    },
    compareWithToday(date) {
      return this.$options.filters.yymmdd(date) === this.todayIs;
    },
    formatDate(dateString) {
      const dd = Date.parse(dateString);
      return new Intl.DateTimeFormat('et-ee', { dateStyle: 'long', timeStyle: 'short' }).format(dd);
    },
  },
  created() {
    this.getAllEvents();
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
h3 {
  margin: 40px 0 0;
}
ul {
  list-style-type: none;
  padding: 0;
}
li {
  display: inline-block;
  margin: 0 10px;
}
a {
  color: #42b983;
}
</style>
